#!/bin/sh
#
# HighPoint Storage Management Software Installation Script
#

HERE=`pwd`
##########
HPTSVR=hptsvr
FREEBSDVER=`uname -r`
case $FREEBSDVER in
5.*) 
	HPTRAID=hptraid5.0
	;;
4.10*)
	HPTRAID=hptraid4.10
	;;
4.9*) 
	HPTRAID=hptraid4.9
	;;
4.8*) 
	HPTRAID=hptraid4.9
	;;
4.7*) 
	HPTRAID=hptraid4.9
	;;
4.6*)
	HPTRAID=hptraid4.6
	;;
4.1*)
	HPTRAID=hptraid4.1
	HPTSVR=hptsvr4.1
	;;
*)
	HPTRAID=hptraid4.1
	;; 
esac
#echo $HPTRAID
##########

case $1 in
-i) 
	HPTDEL=`ps -cx | grep hptraid`
	if [ "x$HPTDEL" != x ] ; then
		  echo "The software is running. Please stop it first."
		  exit 1
	fi
	
	SVC_PID=`ps -cx | grep hptsvr `
	if [ "x$SVC_PID" != x ] ; then
		echo -n "The service is running. Do you want to stop it?(y/n)"
	 	read yorn
		 	case $yorn in
		 	[nN])
		 		echo "Installation abored."
		 		exit 1
		 		;;
		 	*)
		 		kill $SVC_PID >/dev/null 2>/dev/null
		 		;;
		 	esac
	fi 

	if [ ! -f $HERE/hptraid.tar.gz ] ; then
		echo "Software package not found"
		exit 1
	fi

	if [ -f /usr/bin/hptraid ] ; then
		while true
		do
			echo -n "The software has been installed. Do you want reinstall it?(Y/N) "
		 	read yorn
		 	case $yorn in
		 	[yY])
		 		break
		 		;;
		 	[nN])
		 		exit 1
		 		;;
		 	*)
		 		continue
		 		;;
		 	esac
		done
		
		rm -f /var/log/hpt.log
		rm -f /etc/hptuser.dat
		rm -f /etc/hptcfg
		rm -f /etc/hptmailset.dat		
		rm -f /usr/bin/hptsys.log
		rm -f  /usr/bin/hptraid
		rm -f  /root/Desktop/hptraid
		rm -f  /usr/local/share/applnk/Applications/hptraid.desktop
		rm -f  /usr/X11R6/share/gnome/apps/Applications/hptraid.desktop

		rm -rf /usr/bin/res
		rm -rf /usr/bin/help
		rm -f  /usr/bin/hptsvr
		rm -f /usr/bin/hptsvrman.sh		
		rm -f  /usr/bin/hptinstall.sh 
		
		rm -f /usr/bin/hpthelp
		/usr/local/etc/rc.d/hptdaemon.sh stop
		rm -f  /usr/local/etc/rc.d/hptdaemon.sh
	fi
	
	if [ ! -f /etc/hptcfg ]; then
		for drv in hpt374.status hptmv.status hpt37x2.status hpt370.status; do
			sysctl $drv >/dev/null 2>/dev/null
			if [ $? -eq 0 ]; then
				echo $drv > /etc/hptcfg
				break
			fi
		done
		if [ ! -f /etc/hptcfg ]; then
			echo "Can't detect any supported driver automatically."
			echo -n "Please specify a driver: [hptmv]"
			read drv
			[ "$drv" == "" ] && drv=hptmv
			echo $drv > /etc/hptcfg
		fi
	fi	

	cd /tmp
	tar -xzf $HERE/hptraid.tar.gz >/dev/null
	
	cp -f  $HPTRAID  /usr/bin/hptraid
	chmod  544	/usr/bin/hptraid
	mkdir -p /root/Desktop/
	ln -s  /usr/bin/hptraid /root/Desktop/hptraid
	mkdir -p /usr/local/share/applnk/Applications
	mkdir -p /usr/X11R6/share/gnome/apps/Applications/
	cp -f hptraid.kdelnk /usr/local/share/applnk/Applications/
	cp -f hptraid.desktop /usr/X11R6/share/gnome/apps/Applications/
	
	cp -rf res		/usr/bin/
	cp -rf help 		/usr/bin/
	cp -f  $HPTSVR		/usr/bin/hptsvr
	chmod  755	/usr/bin/hptsvr
#	cp -f hptcfg /etc
	
	cp -f hptsvrman.sh /usr/bin/	
	chmod a+x /usr/bin/hptsvrman.sh		
	
	cp -f  $HERE/hptinstall.sh /usr/bin/

	mkdir -p /usr/local/etc/rc.d
	cp -f hptdaemon.sh /usr/local/etc/rc.d/
	chmod 555 /usr/local/etc/rc.d/hptdaemon.sh

	if [ -f /usr/local/bin/netscape ] ; then
		ln /usr/local/bin/netscape /usr/bin/hpthelp
	elif [ -f /usr/local/bin/netscape.run ] ; then
		ln /usr/local/bin/netscape.run /usr/bin/hpthelp
	elif [ -f /usr/X11R6/bin/mozilla ] ; then
		ln /usr/X11R6/bin/mozilla /usr/bin/hpthelp
	elif [ -f /usr/local/bin/mozilla ] ; then
		ln /usr/local/bin/mozilla /usr/bin/hpthelp
	else 
		echo "Warning: Can not find a HTML browser."
		echo "To view help, please make the symbol link /usr/bin/hpthelp to"
		echo "your browser manually."
	fi

	rm -f  hptraid.desktop
	rm -f  hptraid.kdelnk
	rm -f  hptraid*
	rm -f  hptsvrman.sh
	rm -f  hptsvr*
	rm -f  hptcfg
	rm -rf res
	rm -rf help
	rm -f  hptdaemon.sh

	/usr/local/etc/rc.d/hptdaemon.sh start
	echo "HighPoint Storage Management Software has been installed successfully!"
	cd $HERE
	;;

-u)
	HPTDEL=`ps -cx | grep hptraid`
	if [ "x$HPTDEL" != x ] ; then
		  echo "The software is running. Please stop it first."
		  exit 1
	fi
	
	SVC_PID=`ps -cx | grep hptsvr `
	if [ "x$SVC_PID" != x ] ; then
		echo -n "The service is running. Do you want to stop it?(Y/N)"
	 	read yorn
		 	case $yorn in
		 	[nN])
		 		echo "Uninstallation aborted."
		 		exit 1
		 		;;
		 	*)
		 		kill $SVC_PID >/dev/null 2>/dev/null
		 		break
		 		;;
		 	esac
	fi 
	
	if [ -f /usr/bin/hptraid ] ; then
		while true
		do
			echo -n "Are you sure to uninstall HighPoint Storage Management Software?(Y/N)"
			read yesorno
			case $yesorno in
			[yY])
				rm -f /var/log/hpt.log			
				rm -f /etc/hptuser.dat
				rm -f /etc/hptcfg
				rm -f /etc/hptmailset.dat					
				rm -f /usr/bin/hptsys.log
				rm -rf /usr/bin/hptraid
				rm -rf /usr/bin/res
				rm -rf /usr/bin/help
				rm -f  /usr/bin/hptsvr
				rm -f /usr/bin/hptsvrman.sh				
				rm -f  /usr/bin/hptinstall.sh	 
	
				rm -f  /usr/local/share/applnk/Applications/hptraid.*
				rm -f  /usr/X11R6/share/gnome/apps/Applications/hptraid.desktop
				rm -f  /root/Desktop/hptraid
	
				rm -f /usr/bin/hpthelp
				/usr/local/etc/rc.d/hptdaemon.sh stop >/dev/null 2>/dev/null
				rm -f  /usr/local/etc/rc.d/hptdaemon.sh
				
				echo "Uninstall fininshed!" 
				break
				;;
			[nN])
				break
				;;
			*)
				continue
				;;
			esac
		done 
	fi	
    ;;
*)
	echo "Usage: hptinstall.sh { -i | -u }"
	exit 1
	;; 
esac
exit 0
